> This page is for API Reference.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://okx-demo.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://okx-demo.ferndocs.com/_mcp/server.

# Get delivery/exercise history

GET https://www.okx.com/api/v5/public/delivery-exercise-history

Retrieve delivery records of FUTURES and exercise records of OPTIONs in the last 3 months.

Reference: https://okx-demo.ferndocs.com/api/api-reference/public-data/get-delivery-exercise-history

## Request

### Query parameters

- `instType` (enum, required) — Instrument type.
  - Allowed values: `FUTURES`, `OPTION`
- `uly` (string, optional) — Underlying, e.g. BTC-USD. Either uly or instFamily is required.
- `instFamily` (string, optional) — Instrument family, e.g. BTC-USD. Either uly or instFamily is required.
- `after` (string, optional) — Pagination of data to return records earlier than the requested ts, Unix timestamp in milliseconds.
- `before` (string, optional) — Pagination of data to return records newer than the requested ts, Unix timestamp in milliseconds.
- `limit` (string, optional) — Number of results per request. The maximum is 100; the default is 100.

## Response

### 200

Successful response

- `code` (string, optional) — Result code. `0` means success; any other value is an error code.
- `msg` (string, optional) — Error message. Empty on success.
- `data` (list of ApiV5PublicDeliveryExerciseHistoryGetResponsesContentApplicationJsonSchemaDataItems, optional)

## Types

### ApiV5PublicDeliveryExerciseHistoryGetResponsesContentApplicationJsonSchemaDataItems

- `ts` (string, optional) — Delivery/exercise time, Unix timestamp in milliseconds.
- `details` (list of ApiV5PublicDeliveryExerciseHistoryGetResponsesContentApplicationJsonSchemaDataItemsDetailsItems, optional) — Delivery/exercise details.

### ApiV5PublicDeliveryExerciseHistoryGetResponsesContentApplicationJsonSchemaDataItemsDetailsItems

- `instId` (string, optional) — Delivery/exercise contract ID.
- `px` (string, optional) — Delivery/exercise price.
- `type` (string, optional) — Type: delivery, exercised, or expired_otm (expired out of the money).

## Examples

**Response**

```json
{
  "code": "0",
  "msg": "",
  "data": [
    {
      "ts": "1597026383085",
      "details": [
        {
          "px": "0.016",
          "type": "delivery",
          "insId": "BTC-USD-190927"
        }
      ]
    },
    {
      "ts": "1597026383085",
      "details": [
        {
          "px": "0.016",
          "type": "exercised",
          "insId": "BTC-USD-200529-6000-C"
        },
        {
          "px": "0.016",
          "type": "exercised",
          "insId": "BTC-USD-200529-8000-C"
        }
      ]
    }
  ]
}
```

**SDK Code**

```python publicData_getDeliveryExerciseHistory_example
import requests

url = "https://www.okx.com/api/v5/public/delivery-exercise-history"

querystring = {"instType":"FUTURES"}

response = requests.get(url, params=querystring)

print(response.json())
```

```javascript publicData_getDeliveryExerciseHistory_example
const url = 'https://www.okx.com/api/v5/public/delivery-exercise-history?instType=FUTURES';
const options = {method: 'GET'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go publicData_getDeliveryExerciseHistory_example
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://www.okx.com/api/v5/public/delivery-exercise-history?instType=FUTURES"

	req, _ := http.NewRequest("GET", url, nil)

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby publicData_getDeliveryExerciseHistory_example
require 'uri'
require 'net/http'

url = URI("https://www.okx.com/api/v5/public/delivery-exercise-history?instType=FUTURES")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)

response = http.request(request)
puts response.read_body
```

```java publicData_getDeliveryExerciseHistory_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://www.okx.com/api/v5/public/delivery-exercise-history?instType=FUTURES")
  .asString();
```

```php publicData_getDeliveryExerciseHistory_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://www.okx.com/api/v5/public/delivery-exercise-history?instType=FUTURES');

echo $response->getBody();
```

```csharp publicData_getDeliveryExerciseHistory_example
using RestSharp;

var client = new RestClient("https://www.okx.com/api/v5/public/delivery-exercise-history?instType=FUTURES");
var request = new RestRequest(Method.GET);
IRestResponse response = client.Execute(request);
```

```swift publicData_getDeliveryExerciseHistory_example
import Foundation

let request = NSMutableURLRequest(url: NSURL(string: "https://www.okx.com/api/v5/public/delivery-exercise-history?instType=FUTURES")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```